
#include <stdarg.h>

void pr(char *fmt, ... ){
        char buf[128]; // resulting string limited to 128 chars
        va_list args;
        va_start (args, fmt );
        vsnprintf(buf, 128, fmt, args);
        va_end (args);
        Serial.println(buf);
}

        


#include "RTClock.h"
RTClock rt (RTCSEL_LSE);

#include <SerialCommand.h>


SerialCommand sCmd;


void cmdwriteseconds(void)
{
 struct tm * tx;
 char * arg;
 arg = sCmd.next();
 if(arg!=NULL)
 {
  tx=rt.getTime(NULL);
  tx->tm_sec=atoi(arg);
  rt.setTime(tx);
 }
}



void cmdwriteminutes(void)
{
 struct tm * tx;  
 char * arg;
 arg = sCmd.next();
 if(arg!=NULL)
 {
  tx=rt.getTime(NULL);
  tx->tm_min=atoi(arg);
  rt.setTime(tx);
 }
}




void cmdwritehours(void)
{
 char * arg;
 struct tm * tx; 
 arg = sCmd.next();
 if(arg!=NULL)
 {
  tx=rt.getTime(NULL);
  tx->tm_hour=atoi(arg);
  rt.setTime(tx);
 }
}

void cmdwritedate(void)
{
 char * arg;
 struct tm * tx;
 arg = sCmd.next();
 if(arg!=NULL)
 {
  tx=rt.getTime(NULL);
  tx->tm_mday=atoi(arg);
  rt.setTime(tx);
 }
}



void cmdwritemonth(void)
{
 char * arg;
 struct tm * tx;
 arg = sCmd.next();
 if(arg!=NULL)
 {
  tx=rt.getTime(NULL);
  tx->tm_mon=atoi(arg)-1;
  rt.setTime(tx);
 }
}


void cmdwriteyear(void)
{
 char * arg;
 struct tm * tx;
 arg = sCmd.next();
 if(arg!=NULL)
 {
  tx=rt.getTime(NULL);
  tx->tm_year=atoi(arg)-1900;
  rt.setTime(tx);
 }
}


void cmdreadtime(void)
{
 time_t t=rt.getTime();
 pr(ctime(&t));

  
}


void cmdunrecognized(const char *command)
{
 Serial.println("What?"); 
}  


void setup() 
{
 Serial.begin(9600);

 sCmd.addCommand("rt",cmdreadtime);
 sCmd.addCommand("ws",cmdwriteseconds);
 sCmd.addCommand("wm",cmdwriteminutes);
 sCmd.addCommand("wh",cmdwritehours);
 sCmd.addCommand("wd",cmdwritedate); 
 sCmd.addCommand("wn",cmdwritemonth); 
 sCmd.addCommand("wy",cmdwriteyear);

 sCmd.setDefaultHandler(cmdunrecognized);
}

void loop() 
{

 if(Serial.available()>0) 
  {
   sCmd.readSerial();
  }

}
